import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.image.BufferedImage;
import java.awt.*;

/**
 * Write a description of class Trail here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Trail  extends Actor
{
    private static final int TRAIL_LIMIT = 15;
    private int count;
   
    
    protected void addedToWorld(World world)
    {
        setImage(new GreenfootImage(world.getWidth(), world.getHeight()));
    }

    public void act() 
    {
        count -= 1;
        if (count <= 0) // only keep trail from every other frame
        {
            GreenfootImage latestImg = ((KinectWorld)getWorld()).getCombinedUserImage();
            if (latestImg == null)
                return;
            latestImg.scale(getWorld().getWidth(), getWorld().getHeight());
            // One way to program this demo would be to keep a list of trail images
            // and then each frame, paint them on top of each other.
            // However, having done this, it ran quite slowly on slower machines,
            // because painting 15 full-sized images on top of each other took too
            // much time.  Therefore this scenario uses a more advanced method,
            // using efficient image-compositing operations to produce the fading effect
            // by just copying the last image each time and compositing it with the
            // latest one.
            
            // We want a totally black image, and the alpha of the destination should be:
            // (where U = latest user image, T = previous trail image)
            // U == 1 => 1
            // U == 0 => T * 0.8
            
            GreenfootImage newImage = new GreenfootImage(getWorld().getWidth(), getWorld().getHeight());
            newImage.setColor(new Color(Greenfoot.getRandomNumber(255), Greenfoot.getRandomNumber(255), Greenfoot.getRandomNumber(255), 255)); // Must use alpha 1
            //newImage.setColor(new Color(0, 0, 0, 255)); // Must use alpha 1
            newImage.fill();
            Graphics2D g = newImage.getAwtImage().createGraphics();
            //g.setComposite(AlphaComposite.getInstance(AlphaComposite.DST_ATOP));
            g.setComposite(AlphaComposite.getInstance(AlphaComposite.DST_ATOP));
            //This will copy the src alpha across (which is 1s and 0s), and set the colour to black
            g.drawImage(latestImg.getAwtImage(), 0, 0, null);
            // This will use the dest alpha where is 1, and the src alpha when dest alpha is 0,
            // and the colour won't matter because it's black on black:
            g.setComposite(AlphaComposite.getInstance(AlphaComposite.DST_OVER, 0.8f));
            g.drawImage(getImage().getAwtImage(), 0, 0, null);
            g.dispose();
            setImage(newImage);
            count = 2;
        }
    }    
}
